const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_transactions = sequelize.define(
    'inventory_transactions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

transaction_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"receipt",


"issue_to_production",


"return_from_production",


"transfer_in",


"transfer_out",


"adjustment",


"scrap"

        ],

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

transaction_at: {
        type: DataTypes.DATE,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_transactions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.inventory_transactions.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.inventory_lots, {
      as: 'lot',
      foreignKey: {
        name: 'lotId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'performed_by',
      foreignKey: {
        name: 'performed_byId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.inventory_transactions.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.inventory_transactions.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.inventory_transactions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_transactions;
};


